#include "lcd_ks0108.h"
#include "intrins.h"

// ??????(?10us@11.0592MHz)
void LCD_Delay(unsigned int t) {
    while(t--) _nop_();
}
/**********************************************
* ???:LCD_WriteCmd
* ??:?KS0108????
* ??:cmd-???, chip-????(0:???,1:???)
**********************************************/
void LCD_WriteCmd(unsigned char cmd, unsigned char chip) {
    LCD_EN = 0;
    LCD_RS = 0;  // ????
    LCD_RW = 0;  // ???
    
    // ????(??!KS0108??)
    LCD_CS1 = (chip == 0) ? 0 : 1;
    LCD_CS2 = (chip == 1) ? 0 : 1;
    
    LCD_DATA = cmd;     // ????
    LCD_Delay(15);      // ??????
    LCD_EN = 1;         // ?????
    LCD_Delay(15);      // EN???????>450ns
    LCD_EN = 0;         // ???????
}

/**********************************************
* ???:LCD_WriteData
* ??:?KS0108??????
**********************************************/
void LCD_WriteData(unsigned char dat, unsigned char chip) {
    LCD_EN = 0;
    LCD_RS = 1;  // ????
    LCD_RW = 0;
    
    LCD_CS1 = (chip == 0) ? 0 : 1;
    LCD_CS2 = (chip == 1) ? 0 : 1;
    
    LCD_DATA = dat;
    LCD_Delay(15);
    LCD_EN = 1;
    LCD_Delay(15);
    LCD_EN = 0;
}

/**********************************************
* ???:LCD_SetPosition
* ??:??????(???????)
* ??:page-?(0-7), y-?(0-63), chip-????
**********************************************/
void LCD_SetPosition(unsigned char page, unsigned char y, unsigned char chip) {
    LCD_WriteCmd(CMD_SET_PAGE | (page & 0x07), chip);
    LCD_WriteCmd(CMD_SET_Y | (y & 0x3F), chip);
}

/**********************************************
* ???:LCD_Init
* ??:???LCD???
**********************************************/
void LCD_Init(void) {
    // ??IO??
    P0M0 = 0x00; P0M1 = 0x00;  // P0???
    P2M0 = 0xFF; P2M1 = 0x00;  // P2????
    
    LCD_CS1 = 1;  // ??????
    LCD_CS2 = 1;
    LCD_EN = 0;
    
    // KS0108?????
    LCD_WriteCmd(CMD_DISP_OFF, 0);  // ?????
    LCD_WriteCmd(CMD_DISP_OFF, 1);  // ?????
    LCD_WriteCmd(CMD_START_LINE, 0);// ?????=0
    LCD_WriteCmd(CMD_START_LINE, 1);
    LCD_Delay(5000);               // ??5ms
    
    LCD_WriteCmd(CMD_DISP_ON, 0);   // ?????
    LCD_WriteCmd(CMD_DISP_ON, 1);   // ?????
	// ?LCD_Init()???:
LCD_WriteData(0xFF, 0); // ???????
LCD_WriteData(0x55, 1); // ????????
}

/**********************************************
* ???:LCD_Clear
* ??:??(??0x00)
**********************************************/
void LCD_Clear(void) {
    unsigned char page, y, chip;
    
    for(chip=0; chip<2; chip++) {
        for(page=0; page<8; page++) {
            LCD_SetPosition(page, 0, chip);
            for(y=0; y<64; y++) {
                LCD_WriteData(0x00, chip);
            }
        }
    }
}

/**********************************************
* ???:LCD_ShowString
* ??:?????(???????)
* ??:page-???(0-7), y-???(0-63)
*       str-?????, chip-????
**********************************************/
void LCD_ShowString(unsigned char page, unsigned char y, unsigned char *str, unsigned char chip) {
    unsigned char curr_page = page;
    unsigned char curr_y = y;
    
    LCD_SetPosition(curr_page, curr_y, chip);
    
    while(*str) {
        // ??????(16x16????????)
        LCD_WriteData(*str++, chip);  // ????
        LCD_WriteData(*str++, chip);  // ????
        
        curr_y += 16;  // ?????16?
        if(curr_y >= 64) {
            curr_y = 0;
            if(++curr_page >= 8) break;
            LCD_SetPosition(curr_page, curr_y, chip);
        }
    }
}

/**********************************************
* ???:LCD_ShowImage
* ??:????(?????)
* ??:page-???, y-???
*       img-??????, width-????(??)
**********************************************/
void LCD_ShowImage(unsigned char page, unsigned char y, const unsigned char *img, unsigned char width) {
    unsigned char chip = (y >= 64) ? 1 : 0;  // ???????
    unsigned char start_y = y % 64;
    unsigned char i;
    
    LCD_SetPosition(page, start_y, chip);
    
    for(i=0; i<width; i++) {
        if((start_y + i) >= 64) {  // ????
            chip = 1;
            start_y = 0;
            LCD_SetPosition(page, start_y, chip);
        }
        LCD_WriteData(*img++, chip);
    }
}


