#ifndef __LCD_KS0108_H
#define __LCD_KS0108_H

#include "stc8h.h"

// ??????
#define LCD_DATA    P2
sbit LCD_RS  = P3^3;  // DI
sbit LCD_RW  = P3^7;
sbit LCD_EN  = P3^2;
sbit LCD_CS1 = P3^4;  // ???
sbit LCD_CS2 = P3^5;  // ???
sbit LCD_RST = P3^6;
// KS0108???
#define CMD_DISP_ON   0x3F
#define CMD_DISP_OFF  0x3E
#define CMD_SET_PAGE  0xB8  // +0~7
#define CMD_SET_Y     0x40  // +0~63
#define CMD_START_LINE 0xC0 // +0~63

// ????
void LCD_Delay(unsigned int t);
void LCD_Init(void);
void LCD_Clear(void);
void LCD_WriteCmd(unsigned char cmd, unsigned char chip);
void LCD_WriteData(unsigned char dat, unsigned char chip);
void LCD_SetPosition(unsigned char page, unsigned char y, unsigned char chip);
void LCD_ShowString(unsigned char page, unsigned char y, unsigned char *str, unsigned char chip);
void LCD_ShowImage(unsigned char page, unsigned char y, const unsigned char *img, unsigned char width);
void Delay5ms(void);
void Delay100ms(void);
void Delay1000ms(void);
#endif